        PROGRAM modscore_three                        
c	************************************************
C       ************************************************
C	Three point linkage analysis of quantitative traits
C	Pedigrees without loops
C	Elston-Stewart algorithm	
c	Qtl - two alleles
c	Marker - two 2 alleles loci    
c	QTL placed between two adjacent markers
C	************************************************
C	************************************************
C	pr(1)=frequency of qtl allele(p)
C	pr(2)-pr(4)=mu1,mu2,mu3 - genotypic means 
C	pr(5)=teta
c	pr(6)=sigma_environment
C	pr(7)=pga (effect of a single polygeen)
C	pr(8)-pr(9)=frequencies of alleles for two marker loci
C	************************************************
C	************************************************ 
	implicit double precision(a-h,o-z)
	EXTERNAL GENMMP
	include 'mas_size.inc'
c	************************************************
C	here the user common-blocks are coming
C	************************************************
	include 'usercom.inc'
	include 'methcom.inc'
	character*20 name_phen,name_mar,name_out,name_map,name 
	dimension pr0(10),st0(10),icp0(10)
 
	NPR=7
C	************************************************
c	************************************************
C	READ: file names
C	************************************************
	open (unit=1,file='task.inp')
	read (1,*)name_phen
	read (1,*)name_mar  
	read (1,*)name_out
	read (1,*)name_map
	close (unit=1)
        OPEN (UNIT=10,file=name_out)

	open (unit=1,file=name_mar)
	read (1,*)n_mar 
	if (n_mar.gt.N_LOCI)then
	print *,'Increase N_LOCI size in mas_size.inc'
	pause
	stop
	end if

	i=0
345	i=i+1
	read (1,*,end=346)(igen(i,j),j=1,n_mar)
	goto 345
346	close (unit=1)
	ndat=i-1
c	print *,ndat

	open (unit=1,file=name_map)
	read (1,*)
	i=0
745	i=i+1
	read (1,*,end=746)n1,name, a,qmap(i)
	goto 745
746	close (unit=1)

	open (unit=1,file='par.inp')
	read (1,*)
        DO  j=1,NPR
	    READ(1,*)inum(j),icp(j),PR(j),ST(j),GL(j),GR(j)
	end do
        CLOSE (UNIT=1)
	do i=1,npr
	pr0(i)=pr(i)
	st0(i)=st(i)
	icp0(i)=icp(i)
	end do
                 
C	***************************************************
C	MASSIV BEP and MASSIV QQ
C	***************************************************

	CALL FOM_BEP
	

	cnst=0.5**6
	do ipol=1,7
	qq(ipol)=CNK(6,ipol-1)*cnst
	end do
c	pause 'end fom QQ'

C	************************************************
        call wwdat(name_phen)
C	************************************************
	if (pr(7)==0.)then
	VOLPG=1
	qq(1)=1.
	end if   

   	do iimar=1,n_mar-1 
	do j=1,ndat
	mark(j,1)=igen(j,iimar)
	mark(j,2)=igen(j,iimar+1)
	end do

                 
	IPOV=1

555	do i=1,npr
	pr(i)=pr0(i)
	st(i)=st0(i)
	icp(i)=icp0(i)
	end do
C	************************************************
C	************************************************
C	READ: initial parameters of model
C	************************************************
	pr(5)=(qmap(iimar+1)-qmap(iimar))*0.01 !!!!!!!!!!!!!!!!!!
c	print *,'map: ',qmap(iimar),qmap(iimar+1)

	if (IPOV.eq.1) then
	do i=1,npr
	icp(i)=0
	end do
	end if

	n_icp=0
	do i=1,npr
	n_icp=n_icp+icp(i)
	end do



	if (IPOV.eq.1)then	
	call freq(f1,f2,i_err)
	if (i_err.eq.1)goto 5151
	pr(8)=f1 
	pr(9)=f2 
	if (f1.lt.1.e-03.or.f2.lt.1.e-03)goto 5151
	end if

777     IMAX=-1
	CALL GENMMP(F0)
	print 8887,iimar,f0

8887	format (i3,' initial LH=',e15.8)
	H=F0
	if (n_icp.eq.0) goto 666
        if (F0.le.-1.d17)stop
666     if (IPOV.eq.1)then
	h1=h
1010	Format ('LH(0.5)=',E14.7)
	else
	f_lh=2.*(h-h1)
	f_LOD=f_lh/4.6
	Write (10,1011)iimar,h1,H,f_LOD
	end if
1012	Format ('-2ln(L1/L2)=',E14.7)
1011	Format (i4,2E14.6,3x,E11.4)
1013	Format ('LOD SCORE=',E14.7)
1015	format (i4,5e11.4)	

	if (IPOV.eq.2)goto 888
	IPOV=2
	goto 555
888     close(unit=12)
5151	end do
	close(unit=10)
1111	format(20i1)
        END
C	************************************************
      SUBROUTINE GENMMP(FLH)
C	************************************************
C	LH for pedigree sample 
C	************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  	include 'mas_size.inc'
	include 'usercom.inc'
	include 'methcom.inc'
C	************************************************
	if (imax.eq.-1)then
	call stap0(ch)
	goto 9999
	else
	call stapar(ch)
	end if
9999	if(ch+1.e18)92,92,99
9992	if (max.eq.-1)then
	print 9993,is
	pause
	end if
9993	format (' PROBABILITY OF FAMILY',i4,'=0')
92	FLH=-1.e18
	return
99	FLH=0.
	NS=INS(1)
	DO 1 IS=1,NS
100	LS0=INS(IS+1)
	LS1=LS0+1
	LS2=INS(IS+2)
	LSS=ls2-ls0
	Lp1=ips(is+1)+1
	Lp2=ips(is+2)
	lps=lp2-lp1+1
	CALL MASSIX(IS)

20	CALL MMPFAM(IS,FS)

	FLH=FLH+FS
1	CONTINUE
	RETURN
	END
c	**************************************
        SUBROUTINE WWDAT(name_phen)
	implicit double precision (a-h,o-z)
c	***************************************
	include 'mas_size.inc'
	include 'usercom.inc'
	character*10 name_phen,name_mar
        OPEN (UNIT=2,file='IWAY.DAT')
        READ (2,*)NS,(INS(J),J=1,NS+2)
	if (NS.gt.N_FAM+2)stop'N_FAM exceed. Correct and recompile'
        READ (2,*)(IPS(J),J=1,NS+2)
        READ (2,*)LSS,(INP(J),J=1,LSS)
	if (LSS.gt.N_WAY)stop'N_WAY exceed. Correct and recompile'
        read (2,*)LS,(INF(J),J=1,LS)
	if (LS.gt.N_WAY)stop'N_WAY exceed. Correct and recompile'
        read (2,*)(IWAY(j),j=1,LSS-2)
        read (2,*)nd,(jsex(i),i=1,nd)
	if (ND.gt.N_SIZE)stop'N_SIZE exceed. Correct and recompile'
        read (2,*)(iprob(i),i=1,nd)
2       close (unit=2)
c	print *, nd
        OPEN (UNIT=2,file=name_phen)
	read (2,*)(dat(i),i=1,nd)
	n=0 
	do i=1,nd
	if (dat(i).gt.-990)n=n+1
	end do
	close (unit=2)
	print *,'Number of measured persons=',n

        RETURN
        END
c	*********************************************************
c	*********************************************************
        SUBROUTINE STAP0(CH)
	implicit double precision (a-h,o-z)
c	*********************************************************
	include 'mas_size.inc'
	include 'usercom.inc'
	include 'methcom.inc'
	dimension hh(10),k_gen(8)
	dimension n_gen(10)
	dimension n1_05(12),n2_05(12),n_25(8),n1_25(8),n2_25(8)
	data k_gen /0,8,15,21,26,30,33,35/
	data k_mar1/1,1,2,2,1,1,2,2,1,2,2,1,1,2,2,3,3,2,2,3,3,3,
     *	2,2,3,3,1,1,2,2,1,2,2,3,3,3/
	data k_mar2/1,2,1,2,1,2,1,2,3,2,3,2,3,2,3,1,2,1,2,1,2,3,
     *	2,3,2,3,1,2,1,2,3,2,3,1,2,3/
	data k_qtl/1,1,1,1,2,2,2,2,1,1,1,2,2,2,2,1,1,2,2,2,2,1,
     *	2,2,2,2,3,3,3,3,3,3,3,3,3,3/
	data n1_05/1,1,1,2,2,3,3,4,5,5,6,7/
	data n2_05/2,3,5,4,6,4,7,8,6,7,8,8/
	data n_25/6,7,12,15,18,21,24,25/
	data n1_25/1,1,1,2,1,3,2,3/
	data n2_25/2,3,2,4,3,4,4,4/

	CH=one
	do 55 J=1,npr
	nnn=inum(j)
	if(nnn.eq.j)goto 55
	icp(j)=0
	pr(j)=pr(nnn)
55	continue
        DO 90 J=1,NPR
        if (icp(j).eq.0)goto 90
        IF (PR(J).Le.GL(J))GOTO 92
        IF (GR(J).Le.PR(J))GOTO 92
90      CONTINUE
	if (pr(2).lt.pr(4))goto 92

c	frequencies of haplotypes
	n=0
	do i=1,2
        q=PR(1)
	if (i.eq.2)q=one-q
	do j=1,2
	f1=pr(1+NPR)
	if (j.eq.2)f1=one-f1
	do k=1,2
	f2=pr(2+NPR)
	if (k.eq.2)f2=one-f2
	n=n+1
	hh(n)=q*f1*f2
	end do
	end do
	end do

c	frequencies of genotypes
	do i=1,36
	PP(i)=0.
	end do
 
	do i1=1,8
	do i2=1,8
	kk=k_gen(i1)+i2-i1+1
	if (i2.lt.i1)kk=k_gen(i2)+i1-i2+1
	PP(kk)=PP(kk)+hh(i1)*hh(i2)
	end do
	end do

	ppp=0
	do i=1,10
	ppp=ppp+pp(i)
	end do
	if (ppp-one.gt.1.d-07)then
	print *,'Sum_p.ne.1',ppp
	pause
	end if
 
	do i=1,36
	do j=1,8
	be(i,j)=0.D+00
	end do
	end do

	t0=pr(5) !!!!distance between markers
	teta=0.5*(one-dexp(-2.*t0))

	do i=1,8
	kk=k_gen(i)+1
	be(kk,i)=one
	end do
  
	do i=1,12
	i1=n1_05(i)
	i2=n2_05(i)
	kk=k_gen(i1)+i2-i1+1
	be(kk,i1)=0.5D+00
	be(kk,i2)=0.5D+00
	end do

	do i=1,8
	kk=n_25(i)
	be(kk,n1_25(i))=0.25D+00
	be(kk,n2_25(i))=0.25D+00
	be(kk,n1_25(i)+4)=0.25D+00
	be(kk,n2_25(i)+4)=0.25D+00
	end do

	be(4,1)=0.5*(one-teta)
	be(4,4)=0.5*(one-teta)
	be(4,2)=0.5*teta
	be(4,3)=0.5*teta
	be(10,2)=0.5*(one-teta)
	be(10,3)=0.5*(one-teta)
	be(10,1)=0.5*teta
	be(10,4)=0.5*teta
	be(30,5)=0.5*(one-teta)
	be(30,8)=0.5*(one-teta)
	be(30,6)=0.5*teta
	be(30,7)=0.5*teta
	be(32,6)=0.5*(one-teta)
	be(32,7)=0.5*(one-teta)
	be(32,5)=0.5*teta
	be(32,8)=0.5*teta

	be(8,1)=0.25*(one-teta)
	be(8,4)=0.25*(one-teta)
	be(8,5)=0.25*(one-teta)
	be(8,8)=0.25*(one-teta)
	be(8,2)=0.25*teta
	be(8,3)=0.25*teta
	be(8,6)=0.25*teta
	be(8,7)=0.25*teta
	be(23,1)=0.25*(one-teta)
	be(23,4)=0.25*(one-teta)
	be(23,5)=0.25*(one-teta)
	be(23,8)=0.25*(one-teta)
	be(23,2)=0.25*teta
	be(23,3)=0.25*teta
	be(23,6)=0.25*teta
	be(23,7)=0.25*teta
	be(14,2)=0.25*(one-teta)
	be(14,3)=0.25*(one-teta)
	be(14,6)=0.25*(one-teta)
	be(14,7)=0.25*(one-teta)
	be(14,1)=0.25*teta
	be(14,4)=0.25*teta
	be(14,5)=0.25*teta
	be(14,8)=0.25*teta
	be(19,2)=0.25*(one-teta)
	be(19,3)=0.25*(one-teta)
	be(19,6)=0.25*(one-teta)
	be(19,7)=0.25*(one-teta)
	be(19,1)=0.25*teta
	be(19,4)=0.25*teta
	be(19,5)=0.25*teta
	be(19,8)=0.25*teta
	if (ipov.eq.1)goto 333
	t1=0.5*t0	                       	
	tt=0.5*(one-dexp(-2.*t1))
	be(6,1)=0.5*(one-tt)
	be(6,6)=0.5*(one-tt)
	be(6,2)=0.5*tt
	be(6,5)=0.5*tt
	be(7,1)=0.5*(one-tt)
	be(7,7)=0.5*(one-tt)
	be(7,3)=0.5*tt
	be(7,5)=0.5*tt
	be(15,2)=0.5*(one-tt)
	be(15,8)=0.5*(one-tt)
	be(15,6)=0.5*tt
	be(15,4)=0.5*tt
	be(18,3)=0.5*(one-tt)
	be(18,5)=0.5*(one-tt)
	be(18,1)=0.5*tt
	be(18,7)=0.5*tt
	be(21,3)=0.5*(one-tt)
	be(21,8)=0.5*(one-tt)
	be(21,4)=0.5*tt
	be(21,7)=0.5*tt
	be(24,4)=0.5*(one-tt)
	be(24,6)=0.5*(one-tt)
	be(24,2)=0.5*tt
	be(24,8)=0.5*tt
	be(25,4)=0.5*(one-tt)
	be(25,7)=0.5*(one-tt)
	be(25,3)=0.5*tt
	be(25,8)=0.5*tt

	a1=0.5*(one-tt)*(one-tt)
	a2=0.5*tt*(one-tt)
	a3=0.5*tt*tt
	be(8,1)=a1
	be(8,2)=a2
	be(8,3)=a2
	be(8,4)=a3
	be(8,5)=a3
	be(8,6)=a2
	be(8,7)=a2
	be(8,8)=a1
	be(14,1)=a2
	be(14,2)=a1
	be(14,3)=a3
	be(14,4)=a2
	be(14,5)=a2
	be(14,6)=a3
	be(14,7)=a1
	be(14,8)=a2
	be(23,1)=a3
	be(23,2)=a2
	be(23,3)=a2
	be(23,4)=a1
	be(23,5)=a1
	be(23,6)=a2
	be(23,7)=a2
	be(23,8)=a3
	be(19,1)=a2
	be(19,2)=a3
	be(19,3)=a1
	be(19,4)=a2
	be(19,5)=a2
	be(19,6)=a1
	be(19,7)=a3
	be(19,8)=a2

333	do i=1,46656
	bbb(i)=0.D+00
	end do

	do i=1,36
	do j=1,36
	ppp=0.D+00
	do k1=1,8
	b1=be(i,k1)
	do k2=1,8
	kk=k_gen(k1)+k2-k1+1
	if (k2.lt.k1)kk=k_gen(k2)+k1-k2+1
	bbb(1296*(i-1)+36*(j-1)+kk)=bbb(1296*(i-1)+36*(j-1)+kk)+b1*be(j,k2)
	ppp=ppp+b1*be(j,k2)
	end do
	end do
	if (ppp-one.gt.1.d-10)then
	print *,'Sum_bbb.ne.1',i,j
	pause
	end if
	end do
	end do

	smu(1)=pr(2)
	smu(2)=pr(3)
	smu(3)=pr(4)
	pga=pr(7)
	sigma=dsqrt(pr(6))
	call GENOTYPE      
	goto 200
92      CH=-1.d18

200	RETURN
        END
c	***********************************************************
c	*********************************************************
        SUBROUTINE STAPAR(CH)
	implicit double precision (a-h,o-z)
c	*********************************************************
	include 'mas_size.inc'
	include 'usercom.inc'
	include 'methcom.inc'
	dimension hh(8),k_gen(8)
	data k_gen /0,8,15,21,26,30,33,35/
	CH=one
	do 55 J=1,npr
	nnn=inum(j)
	if(nnn.eq.j)goto 55
	icp(j)=0
	pr(j)=pr(nnn)
55	continue
        DO 90 J=1,NPR
        if (icp(j).eq.0)goto 90
        IF (PR(J).Le.GL(J))GOTO 92
        IF (GR(J).Le.PR(J))GOTO 92
90      CONTINUE
	if (pr(2).lt.pr(4))goto 92

c	frequencies of haplotypes
	n=0
	do i=1,2
        q=PR(1)
	if (i.eq.2)q=one-q
	do j=1,2
	f1=pr(1+NPR)
	if (j.eq.2)f1=one-f1
	do k=1,2
	f2=pr(2+NPR)
	if (k.eq.2)f2=one-f2
	n=n+1
	hh(n)=q*f1*f2
	end do
	end do
	end do

c	frequencies of genotypes
	do i=1,36
	PP(i)=0.
	end do
 
	do i1=1,8
	do i2=1,8
	kk=k_gen(i1)+i2-i1+1
	if (i2.lt.i1)kk=k_gen(i2)+i1-i2+1
	PP(kk)=PP(kk)+hh(i1)*hh(i2)
	end do
	end do

 
	smu(1)=pr(2)
	smu(2)=pr(3)
	smu(3)=pr(4)
	pga=pr(7)
	sigma=dsqrt(pr(6))
  
	goto 200
92      CH=-1.d18
200     RETURN
        END
c	***********************************************************

c	
	FUNCTION FEN(M,IG,ipol)
C	********************************
C	M - number of person, IG - his/her genotype
C	********************************
	implicit double precision (a-h,o-z)
	include 'mas_size.inc'
	include 'usercom.inc'
	F=one
	ddd=dat(m)
	mmm=1
	mmm1=mark(m,1)
	mmm2=mark(m,2)
	if (mmm1.eq.0.or.mmm2.eq.0)mmm=0
	if (ddd.le.-998.and.mmm.eq.0)goto 555
7	ig_qtl=k_qtl(ig)
	ig_mar1=k_mar1(ig)              
	ig_mar2=k_mar2(ig)              
	if (mmm1.eq.0) goto 323
	if (mmm1.ne.ig_mar1) goto 222
323	if (mmm2.eq.0)goto 223
	if (mmm2.ne.ig_mar2) goto 222
223	if (ddd.le.-998)goto 555
	xxx=smu(ig_qtl)+pga*(ipol-4)
       	y=(xxx-ddd)/sigma
	z1=dexp(-0.5*y*y)
	f=z1/sigma

	goto 555
222	f=0.D+00
555	fen=f
	return
	end
C*******************************************************      
      SUBROUTINE MASSIX(IS)
C***************************************
C    WRITING OF MASSIV XX
C***************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	include 'mas_size.inc'
	include 'usercom.inc'
      DIMENSION IYK(N_SIZE)
C**********************************************************************
	LSO=INS(IS+1)      !NUMBER OF PERSONS UP TO FAMILY IS
	LS2=INS(IS+2)
       LSS=LS2-LSO  !NUMBER OF MEMBERS IN FAMILY IS
	LG0=IGS(LSO+2)
	LGS=IGS(LS2+2)-LG0

C*****Start of massives XX and IYK***************************
       DO I=1,LSS
        IYK(I)=0
	end do
	nn=0
        DO IG=1,LGS
	DO ipol=1,VOLPG
	nn=7*(IG-1)+ipol
	if (nn.gt.N_WAY)then
	print *,'Increase N_WAY in mas_size.inc'
	pause
	stop
	end if
        XX(7*(IG-1)+ipol)=one
	end do
	end do
c	print *,'nn=',nn
C*********************************************************
       LP0=IPS(IS+1) !NUMBER OF NUCL.FAMILIES UP TO IS      
       LP1=LP0+1 !NUMBER OF FIRST NUCLEAR FAMILY
       LP2=IPS(IS+2) ! NUMPER OF LAST NUCLEAR FAMILY
       LPS=IPS(IS+2)-LP0 !NUMBER OF NUCL.FAMILIES IN FAMILY IS
	IF (LPS.LE.0)GOTO 888
C ******WRITING OF XX FOR OFFSPRINGS*****************************
        DO 24 IQ=LP1,LP2 
         LN0=INP(IQ+1) !NUMBER OF PERSONS UP TO NUCL.FAMILY IQ
         LNS=INP(IQ+2)-LN0 !NUMBER OF PERSONS IN NUCL.FAMILY IQ
         IF(LNS.LE.2)GOTO 24
	nfat=LN0+1		!ADDRESS OF FATHER
	nmat=LN0+2		!ADDRESS OF MOTHER
         NNF1=LN0+3              !ADDRESS OF THE FIRST OFFSPRING
         NNF2=LN0+LNS            !ADDRESS OF THE LAST OFFSPRING
          DO 3 IO=NNF1,NNF2      
           NOFF=INF(IO)          !NUMBER OF OFFSPRING WITH ADDRES IO 
           IO1=NOFF+LSO          !COMMON NUMBER OF THIS OFFSPRING
           D=DAT(IO1)          !TRAIT OF THIS OFFSPRING
           IYK(NOFF)=1            !INDICATOR OF XX WRITING
           IF(D.LE.-1.d+07)GOTO 3
            DO 2 IIG=1,i0_gen(IO1)
            IG=i_gen(IGS(IO1+1)+IIG)
		DO 2 ipol=1,VOLPG
             XX(7*(IGS(IO1+1)+IIG-LG0-1)+ipol)=FEN(IO1,IG,ipol)
2           CONTINUE
3         CONTINUE
24     CONTINUE
C*********WRITING OF XX FOR PARENTS*************
        DO 74 IQ=LP1,LP2           
         LN0=INP(IQ+1)   !NUMBER OF PERSONS UP TO NUCL.FAMILY IQ
         LNS=INP(IQ+2)-LN0  !NUMBER OF PERSONS IN NUCL.FAMILY IQ
	ii=2
	if(lns.eq.1)ii=1
	DO 75 IPAR=1,ii
         NPAR=INF(LN0+IPAR)   !NUMBER OF PARENT
         NFI=NPAR+LSO      !COMMON NUMBER OF PARENT 
         D=DAT(NFI)             !TRAIT OF PARENT
         IF(IYK(NPAR).EQ.1)GOTO 75
         IYK(NPAR)=1
         IF(D.gT.-1.d+07)GOTO 32     
          DO 31 IIG=1,i0_gen(NFI)
          IG=i_gen(IGS(NFI+1)+IIG)      !UNTREATED PARENT
		DO 31 ipol=1,VOLPG

31        XX(7*(IGS(NFI+1)+IIG-LG0-1)+ipol)=PP(IG)*qq(ipol) !FROM POPULATION
	GOTO 75
32         DO 5 IIG=1,i0_gen(NFI)
          IG=i_gen(IGS(NFI+1)+IIG) 
		DO 5 ipol=1,VOLPG

          XX(7*(IGS(NFI+1)+IIG-LG0-1)+ipol)=
     *	FEN(NFI,IG,ipol)*PP(IG)*qq(ipol)
5         CONTINUE
75	CONTINUE
74	CONTINUE
888	DO 101 IO=1,LSS
	IF(IYK(IO).EQ.1)GOTO 101
	NFI=LSO+IO
	D=DAT(NFI)
	IF (D.gt.-1.d+07)GOTO 102
        DO 76 IIG=1,i0_gen(NFI)
        IG=i_gen(IGS(NFI+1)+IIG)
		DO 76 ipol=1,VOLPG

76	XX(7*(IGS(NFI+1)+IIG-LG0-1)+ipol)=PP(IG)*qq(ipol)
	GOTO 101
102     DO 77 IIG=1,i0_gen(NFI)
        IG=i_gen(IGS(NFI+1)+IIG)
		DO 77 ipol=1,VOLPG

77	XX(7*(IGS(NFI+1)+IIG-LG0-1)+ipol)=PP(IG)*FEN(NFI,IG,ipol)*qq(ipol)
101	CONTINUE 

      RETURN
      END

      SUBROUTINE MMPFAM(IS,FS)
C	********************************
C	PEDIGREE CONVOLUTION
C	FS is LOG(LH)
C	********************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	include 'mas_size.inc'
	include 'usercom.inc'
C***************************************************
	LS0=INS(IS+1)
	LSS=INS(IS+2)-LS0 !number of pedigree members
      LP0=IPS(IS+1)   
      LP2=IPS(IS+2)   
      LPS=LP2-LP0 !  number of nucl.families in pedigree IS     
	LG0=IGS(LS0+2)
      FS=0. ! Lukelihood
	PRES=0. ! Parameter of preservation
      IQ=LP0+1   !number of nuclear family
1     NOSB=IWAY(IQ)!number of pointer
      LN0=INP(IQ+1)!start of massive INF
      LN2=INP(IQ+2)
      LNS=LN2-LN0  !size of nuclear family
      NFAT=INF(LN0+1)
      NMAT=INF(LN0+2)
      IFF=1
      IF(NOSB.NE.0)GOTO 12
      NOSB=NFAT
      IFF=0
12    IF(NOSB.NE.NFAT.AND.NOSB.NE.NMAT)GOTO 19
C*****  CONVOLUTION ON ONE OF PARENTS **************      
      KN1=NFAT
      KN2=NMAT
      IF(NOSB.EQ.NFAT)GOTO 13
      KN1=NMAT
      KN2=NFAT

13     	DO 14 IIG1=1,i0_gen(KN1+LS0)
      IG1=i_gen(IGS(KN1+LS0+1)+IIG1)
			DO 14 ipol1=1,VOLPG

      S=0.D+00
      DO 15 IIG2=1,i0_gen(KN2+LS0)
      IG2=i_gen(IGS(KN2+LS0+1)+IIG2)
		DO 15 ipol2=1,VOLPG


      X2=XX(7*(IGS(KN2+1+LS0)+IIG2-LG0-1)+ipol2)
      FS1=one
      IF(LNS.EQ.2)GOTO 27
      DO 16 IO=3,LNS
      IO1=INF(LN0+IO)
      SS=0.D+00
      DO 17 IIG=1,i0_gen(IO1+LS0)
      IG=i_gen(IGS(IO1+LS0+1)+IIG)
		DO 17 ipol=1,VOLPG

                              
17    SS=SS+BBB(1296*(ig1-1)+36*(ig2-1)+ig)*
     *	XX(7*(IGS(IO1+1+LS0)+IIG-LG0-1)+ipol)*
     *	BEP(49*(ipol1-1)+7*(ipol2-1)+ipol)
      FS1=FS1*SS
16    CONTINUE
27    S=S+X2*FS1
15    CONTINUE
      XX(7*(IGS(KN1+1+LS0)+IIG1-LG0-1)+ipol1)=
     *	S*XX(7*(IGS(KN1+1+LS0)+IIG1-LG0-1)+ipol1)
14	continue
      GOTO 66
C*******CONVOLUTION ON ONE OF OFFSPRINGS************
19	IF(LNS.GT.3)GOTO 30
      IO=INF(LN0+3)
      DO 45 IIG0=1,i0_gen(IO+LS0)
      IG0=i_gen(IGS(IO+LS0+1)+IIG0)
		DO 45 ipol0=1,VOLPG
      SS=0.D+00
      DO 46 IIG1=1,i0_gen(NFAT+LS0)
      IG1=i_gen(IGS(NFAT+LS0+1)+IIG1)
		DO 46 ipol1=1,VOLPG
      X1=XX(7*(IGS(NFAT+1+LS0)+IIG1-LG0-1)+ipol1)
      DO 46 IIG2=1,i0_gen(NMAT+LS0)
      IG2=i_gen(IGS(NMAT+LS0+1)+IIG2)
		DO 46 ipol2=1,VOLPG
      SS=SS+X1*XX(7*(IGS(NMAT+1+LS0)+IIG2-LG0-1)+ipol2)*
     *	BBB(1296*(ig1-1)+36*(ig2-1)+ig0)*
     *	BEP(49*(ipol1-1)+7*(ipol2-1)+ipol0)
46    CONTINUE
      XX(7*(IGS(IO+1+LS0)+IIG0-LG0-1)+ipol0)=
     *	SS*XX(7*(IGS(IO+1+LS0)+IIG0-LG0-1)+ipol0)
45    CONTINUE
	GOTO 66            
30    DO 31 IIG0=1,i0_gen(NOSB+LS0)
      IG0=i_gen(IGS(NOSB+LS0+1)+IIG0)
		DO 31 ipol0=1,VOLPG
      SS=0.D+00
      DO 32 IIG1=1,i0_gen(NFAT+LS0)
      IG1=i_gen(IGS(NFAT+LS0+1)+IIG1)
		DO 32 ipol1=1,VOLPG
      X1=XX(7*(IGS(NFAT+1+LS0)+IIG1-LG0-1)+ipol1)
      DO 32 IIG2=1,i0_gen(NMAT+LS0)
      IG2=i_gen(IGS(NMAT+LS0+1)+IIG2)
		DO 32 ipol2=1,VOLPG
      X2=XX(7*(IGS(NMAT+1+LS0)+IIG2-LG0-1)+ipol2)

      FS1=one
      DO 33 IO=4,LNS
	IO1=INF(LN0+IO)
      S=0.D+00
      DO 34 IIG=1,i0_gen(IO1+LS0)
      IG=i_gen(IGS(IO1+LS0+1)+IIG)
		DO 34 ipol=1,VOLPG
34    S=S+BBB(1296*(ig1-1)+36*(ig2-1)+ig)*
     *	XX(7*(IGS(IO1+1+LS0)+IIG-LG0-1)+ipol)*
     *	BEP(49*(ipol1-1)+7*(ipol2-1)+ipol)
      FS1=FS1*S
33    CONTINUE      
      FS1=FS1*BBB(1296*(ig1-1)+36*(ig2-1)+ig0)*
     *	BEP(49*(ipol1-1)+7*(ipol2-1)+ipol0)
      SS=SS+FS1*X1*X2
32    CONTINUE
      XX(7*(IGS(NOSB+1+LS0)+IIG0-LG0-1)+ipol0)=
     *	SS*XX(7*(IGS(NOSB+1+LS0)+IIG0-LG0-1)+ipol0)
31	continue
cc	pause
66    	s=0.D+00
        DO 20 IIG=1,i0_gen(nosb+LS0)
        IG=i_gen(IGS(nosb+LS0+1)+IIG)
		DO 20 ipol=1,VOLPG
20	s=s+xx(7*(IGS(nosb+1+LS0)+iig-LG0-1)+ipol)
777	dds=dlog(s)
	if (s.eq.one)dds=0.D+00
	pres=pres+dds
	ss=one/s
	s=0.D+00
        DO 21 IIG=1,i0_gen(nosb+LS0)
        IG=i_gen(IGS(nosb+LS0+1)+IIG)
		DO 21 ipol=1,VOLPG
	xx(7*(IGS(nosb+1+LS0)+iig-LG0-1)+ipol)=
     *	xx(7*(IGS(nosb+1+LS0)+iig-LG0-1)+ipol)*ss
21	s=s+xx(7*(IGS(nosb+1+LS0)+iig-LG0-1)+ipol)
	IF(IFF.NE.0)GOTO 68
	dds=dlog(s)
	if (s.eq.one)dds=0.D+00
      FS=FS+dds
68    continue
      IQ=IQ+1
      IF(IQ.LE.LP2)GOTO 1
	fs=fs+pres
      RETURN
      END

      SUBROUTINE GENOTYPE
C	*************************************
C	elimination of genotypes 
C	*************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
  	include 'mas_size.inc'
	include 'usercom.inc'
	dimension iflag(36,N_SIZE)
c	**************************************
	NS=INS(1)
	NDAT=INS(NS+2)
	do i=1,36
	do j=1,NDAT
	iflag(i,j)=1
	end do
	end do

C	Testing of personal marker genotype

	N0=0
	do i=1,ndat
	mmm1=mark(i,1)
	mmm2=mark(i,2)
	if (mmm1.eq.0.and.mmm2.eq.0)then
	n0=n0+36 !!!sum_gen
	goto 11
	end if

	if (mmm1.eq.0)then
	do ig=1,36
	if (k_mar2(ig).ne.mmm2)then
	iflag(ig,i)=0
	goto 111
	end if
	N0=N0+1
111	end do
	goto 11
	end if

	if (mmm2.eq.0)then
	do ig=1,36
	if (k_mar1(ig).ne.mmm1)then
	iflag(ig,i)=0
	goto 1112
	end if
	N0=N0+1
1112	end do
	goto 11
	end if

	do ig=1,36
	if (k_mar1(ig).ne.mmm1.or.k_mar2(ig).ne.mmm2)then
	iflag(ig,i)=0
	goto 1113
	end if
	N0=N0+1
1113	end do
11	end do

c	Testing of compatibility with offspring genotypes

200	do is=1,ns
	ls0=ins(is+1)
	lp0=ips(is+1)
	lp1=lp0+1
	lp2=ips(is+2)

	do IQ=lp1,lp2
	LNO=inp(IQ+1)
	LNS=inp(IQ+2)-LNO
	nf=INF(LNO+1)+LS0
	nm=INF(LNO+2)+LS0
	ioff=LNS-2

	do igf=1,36
	if (iflag(igf,nf).eq.0)goto 12
	s=0.D+00

	do igm=1,36
	if (iflag(igm,nm).eq.0)goto 13
	do j=1,ioff
	io=INF(LNO+2+j)+LS0
	do ig=1,36
	if (iflag(ig,io).eq.0)goto 15
	s=s+bbb(1296*(igf-1)+36*(igm-1)+ig)	
15	end do
	end do
13	end do
        if (s.lt.1.d-15)iflag(igf,nf)=0
12	end do

	do igm=1,36
	if (iflag(igm,nm).eq.0)goto 112
	s=0.D+00

	do igf=1,36
	if (iflag(igf,nf).eq.0)goto 113
	do j=1,ioff
	io=INF(LNO+2+j)+LS0
	do ig=1,36
	if (iflag(ig,io).eq.0)goto 115
	s=s+bbb(1296*(igf-1)+36*(igm-1)+ig)	
115	end do
	end do
113	end do
        if (s.lt.1.d-15) iflag(igm,nm)=0
112	end do
	end do

	n1=0
	do i=1,ndat
	do ig=1,36
	if (iflag(ig,i).eq.1)n1=n1+1
	end do
	end do
	end do
	if (n0.gt.n1)then
	n0=n1
	goto 200
	end if
	if (N1.gt.N_WAY) then
	print *,'Number of possible genotypes > N_WAY'
	print *,'Increase N_WAY in mas_size.inc'
	pause
	stop
	end if

	IGS(1)=NDAT
	IGS(2)=0
              
	n=0
	do i=1,NDAT
	do ig=1,36
	if (iflag(ig,i).eq.0)goto 10
	n=n+1
	i_gen(n)=ig
10	end do
	IGS(i+2)=n
	end do

	do i=1,ndat
	i0_gen(i)=IGS(i+2)-IGS(i+1)
	end do

100	format (20i4)
	return
	end


	SUBROUTINE FOM_BEP

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

  	include 'mas_size.inc'
	include 'usercom.inc'

	integer g0,g1,g2
	dimension FOM(4,7)
	vpg=3
	
	VOLPG=2*VPG+1
	denom=1./(CNK(VOLPG-1,(VOLPG-1)/2))

	
	do g1=0,VOLPG-1
	do g0=0,VPG
	
	FOM(g0+1,g1+1)=CNK(g1,g0)*CNK(VOLPG-1-g1,VPG-g0)*denom
	end do
	end do

	do g1=0,VOLPG-1
	i11=max(0,g1-VPG)
	i12=min(3,g1)

	do g2=0,VOLPG-1
	i21=max(0,g2-VPG)
	i22=min(3,g2)

	do g0=i11+i21,i12+i22
	s=0.
	i1=i11
	if(g0.gt.VPG) i1=g0-VPG
	i2=min(i12,g0)
	do i=i1,i2
	s=s+FOM(i+1,g1+1)*FOM(g0-i+1,g2+1)
	end do

	BEP(g0+1+49*g1+7*g2)=s
	end do
	end do
	end do
	

	return
	end



	FUNCTION FAC(N) 

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	FAC=1
	do k=1,N
	FAC=FAC*k
	end do

	return
      end



      FUNCTION CNK(N,K)	
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	if(N.eq.K) then
	CNK=1.
	return
	end if

	if(N.lt.K) then
	CNK=0.
	return
	end if

	CNK=FAC(N)/(FAC(K)*FAC(N-K))

      return
      end

	SUBROUTINE FREQ(f1,f2,i_err)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	include 'mas_size.inc'
	include 'usercom.inc'
	
	dimension num(3),ff(2)
	i_err=0
	NS=INS(1)
	NDAT=INS(NS+2)

	f1=0.
	f2=0.

	do j=1,2

	do i=1,3
	num(i)=0
	end do

	do i=1,ndat
	if(mark(i,j).ne.0)num(mark(i,j))=num(mark(i,j))+1
	end do

	nnn=0
	do i=1,3
	nnn=nnn+num(i)
	end do

	if (nnn.eq.0)then
	i_err=1
	return
	end if

	g=2.*nnn

	ff(j)=(2.*num(1)+num(2))/g
	end do
	f1=ff(1)
	f2=ff(2)
	return
	end
